devtools: give some hints for ABI errors
authorDavid Marchand <david.marchand@redhat.com>
Wed, 8 Jul 2020 09:40:46 +0000 (11:40 +0200)
committerDavid Marchand <david.marchand@redhat.com>
Thu, 16 Jul 2020 06:47:09 +0000 (08:47 +0200)
abidiff can provide some more information about the ABI difference it
detected.
In all cases, a discussion on the mailing must happen but we can give
some hints to know if this is a problem with the script calling abidiff,
a potential ABI breakage or an unambiguous ABI breakage.

Signed-off-by: David Marchand <david.marchand@redhat.com>
Acked-by: Ray Kinsella <mdr@ashroe.eu>
Acked-by: Neil Horman <nhorman@tuxdriver.com>
Acked-by: Aaron Conole <aconole@redhat.com>
devtools/check-abi.sh

index e17fedb..ab6748c 100755 (executable)
@@ -50,10 +50,22 @@ for dump in $(find $refdir -name "*.dump"); do
                error=1
                continue
        fi
-       if ! abidiff $ABIDIFF_OPTIONS $dump $dump2; then
+       abidiff $ABIDIFF_OPTIONS $dump $dump2 || {
+               abiret=$?
                echo "Error: ABI issue reported for 'abidiff $ABIDIFF_OPTIONS $dump $dump2'"
                error=1
-       fi
+               echo
+               if [ $(($abiret & 3)) -ne 0 ]; then
+                       echo "ABIDIFF_ERROR|ABIDIFF_USAGE_ERROR, this could be a script or environment issue."
+               fi
+               if [ $(($abiret & 4)) -ne 0 ]; then
+                       echo "ABIDIFF_ABI_CHANGE, this change requires a review (abidiff flagged this as a potential issue)."
+               fi
+               if [ $(($abiret & 8)) -ne 0 ]; then
+                       echo "ABIDIFF_ABI_INCOMPATIBLE_CHANGE, this change breaks the ABI."
+               fi
+               echo
+       }
 done
 
 [ -z "$error" ] || [ -n "$warnonly" ]